﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private Query As String 
	Public SqlLite As SQL

	Private colNujno As B4XTableColumn
	Private colMatNaroc As B4XTableColumn
	
	Private tblView As B4XTable
	Private btnClose As Button
	
End Sub

Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
	SqlLite.InitializeSQLite(File.DirApp, "miniman.db",  True)
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	InitGrid
	RefreshGrid
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub InitGrid
	
	If tblView.sql1.IsInitialized = True Then tblView.sql1.Close
	
	tblView.Clear
	
	tblView.AddColumn("ID", tblView.COLUMN_TYPE_TEXT)
	colNujno = tblView.AddColumn("Urgent", tblView.COLUMN_TYPE_TEXT)
	colMatNaroc = tblView.AddColumn("Attachment", tblView.COLUMN_TYPE_TEXT)
	tblView.AddColumn("DepartID", tblView.COLUMN_TYPE_TEXT)
	tblView.AddColumn("Department", tblView.COLUMN_TYPE_TEXT)
	tblView.AddColumn("MachineID", tblView.COLUMN_TYPE_TEXT)
	tblView.AddColumn("Machine", tblView.COLUMN_TYPE_TEXT)
	tblView.AddColumn("Date", tblView.COLUMN_TYPE_TEXT)
	tblView.AddColumn("SimptomID", tblView.COLUMN_TYPE_TEXT)
	tblView.AddColumn("Simptom", tblView.COLUMN_TYPE_TEXT)
	tblView.AddColumn("Description", tblView.COLUMN_TYPE_TEXT)
	tblView.AddColumn("User", tblView.COLUMN_TYPE_TEXT)
	tblView.AddColumn("Ind", tblView.COLUMN_TYPE_TEXT)

	tblView.RowHeight = 40dip
	tblView.EvenRowColor = xui.Color_RGB(169,192,201)
	tblView.OddRowColor = xui.Color_RGB(226,243,247)
	
	tblView.SearchVisible = True
	tblView.MaximumRowsPerPage = 30
	tblView.BuildLayoutsCache(tblView.MaximumRowsPerPage)
	tblView.Refresh
	
	For i = 1 To colNujno.CellsLayouts.Size - 1
		Dim parent As B4XView = colNujno.CellsLayouts.Get(i)
		Dim panel As B4XView = xui.CreatePanel("")
		parent.AddView(panel, 0, 0, parent.Width, parent.Height)
		panel.LoadLayout("CheckBox")

		Dim parent As B4XView = colMatNaroc.CellsLayouts.Get(i)
		Dim panel As B4XView = xui.CreatePanel("")
		parent.AddView(panel, 0, 0, parent.Width, parent.Height)
		panel.LoadLayout("CheckBox")

	Next
	
End Sub


' osvežimo prikaz podatkov 
Private Sub RefreshGrid

	' case when exists(select * from dokResNarocMat where dZahIdent = dRNMZahtevekID) then 1 else 0 end as materNarocen

	Query = $"select dZahIdent, dZahNujno, dZahOddelek, sifOddelekDescription, dZahStroj, sifMachineDescription, dZahDatum, dZahSimptom, sifSimptomDescription, dZahOpis, dZahStatus, dZahUser,
	          case when exists(select * from dokResNarocMat where dRNMZahtevekID = dZahIdent) then 1 else 0 end as materNarocen
			  from dokZahtevki inner join sifOddelki on SifOddelekId = dZahOddelek
			                  inner join sifMachine on SifMachineID = dZahStroj 
			 				 inner join sifSimptomi on SifSimptomID = dZahSimptom 
			order by dZahIdent desc"$
	Dim rs As ResultSet = SqlLite.ExecQuery(Query)
	Dim row As List
	row.Initialize
			
	
	Do While rs.NextRow
			
		Dim Status As String
				
		Select Case rs.GetInt("dZahStatus")
			Case 0
				Status = "Open"
			Case 1
				Status = "In Progrees"
			Case 2
				Status = "Waiting"
			Case 3
				Status = "Finished"
			Case 9
				Status = "Deleted"
		End Select
		
		Dim Datum As String = ConvertDateTime(rs.GetString("dZahDatum"),  "yyyy-MM-dd HH:mm:ss", "dd-MM-yy HH:mm:ss")
		row.Add(Array(rs.GetInt("dZahIdent"), rs.GetInt("dZahNujno"), rs.GetInt("materNarocen"),rs.GetString("dZahOddelek"), rs.GetString("sifOddelekDescription"), rs.GetInt("dZahStroj"), _
		        rs.GetString("sifMachineDescription"), Datum,  rs.GetInt("dZahSimptom"), rs.GetString("sifSimptomDescription"), rs.GetString("dZahOpis"), rs.GetString("dZahUser"), Status) )
	Loop
	rs.Close
	
	tblView.SetData(row)
	tblView.Refresh
	
End Sub

Sub ConvertDateTime(Datum As String, FromDateFormat As String, ToDateFormat As String) As String
	Dim dt As String = ""
	
	If Datum.Length = 0 Then Return dt
	
	DateTime.DateFormat = FromDateFormat
	Dim lngDate As Long = DateTime.DateParse(Datum)
	DateTime.DateFormat = ToDateFormat
	dt = DateTime.Date(lngDate)

	Return dt
End Sub

Private Sub btnClose_Click
	B4XPages.ClosePage(Me)	
End Sub

Private Sub tblView_HeaderLongClicked (ColumnId As String)
	Dim tblcol As tableColumnList 
	tblcol.Initialize
	For i = 0 To tblView.Columns.Size - 1
		Dim col As B4XTableColumn = tblView.Columns.Get(i)
		tblcol.tblColums.Put(col.Title, True)
	Next

	' prikažemo tabelo z listo kolon
	tblcol.ShowList
End Sub