﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private xui As XUI
	Private frm As Form

	Private clvColumns As CustomListView
	Private clvNewColumns As CustomListView
	Private chkColCheck As CheckBox
	Private lblColNaziv As Label
	Public tblColums As Map 
	
	Private dragDrop As DragAndDrop
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	tblColums.Initialize
	frm.Initialize("tbl", 580dip, 680dip)
	frm.RootPane.LoadLayout("tblGridView")
	
	dragDrop.Initialize(Me)
	
End Sub

Public Sub ShowList
	
	' columns
	Log(tblColums)
	
	For x = 0 To tblColums.Size - 1
		Dim str As String = tblColums.GetKeyAt(x)
		Dim P As B4XView = CreateListItem(str, clvColumns.AsView.Width, 40dip, x)
		clvColumns.add(P, x)
		dragDrop.MakeDragTarget(P, "clvTarget")
		dragDrop.MakeDragSource(P, "clvSource")
	Next	
	frm.WindowHeight = 50dip * (x - 1)
	frm.ShowAndWait
	
End Sub


Private Sub CreateListItem(Text As String, Width As Int, Height As Int, Index As Int) As B4XView
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, Width, Height)
	p.LoadLayout("ColItems")
	lblColNaziv.Text = Text

	If tblColums.Get(Text).As(Boolean) = True Then chkColCheck.Checked = True Else chkColCheck.Checked = False 
	chkColCheck.Tag = Index 
	Return p
End Sub

Private Sub clvColumns_ItemClick (Index As Int, Value As Object)
	Dim item As CLVItem = clvColumns.GetRawListItem(Index)
	Dim pnl As B4XView = item.Panel.GetView(0)
	Dim chk As CheckBox = pnl.GetView(0)
	Dim lbl As Label = pnl.GetView(1)
	Dim isChecked As Boolean = chk.Checked

	Log("Clicked " & Value)
End Sub


' klik na check box
Private Sub chkColCheck_CheckedChange(Checked As Boolean)
	Dim chk As CheckBox = Sender
	Dim Index As Int = chk.Tag
	Dim item As CLVItem = clvColumns.GetRawListItem(Index)
	Dim pnl As B4XView = item.Panel.GetView(0)
	Dim lbl As Label = pnl.GetView(1)
	Log(lbl.Text)
End Sub


Sub clvSource_DragDetected(e As MouseEvent)
	Log("DragDetected : Starting drag")
	Log(e.As(JavaObject).RunMethod("getSource",Null).As(B4XView).GetView(1).Text)
	Dim P As B4XView = e.As(JavaObject).RunMethod("getSource",Null)
	'
	'Needed to set DragMode
	'
	dragDrop.SetDragModeAndData(TransferMode.MOVE,Array As String("TableData"),Array As String(P.GetView(1).Text))
End Sub

Sub clvSource_DragDone(e As DragEvent)
	Log("DragDone : transfer mode " & e.GetTransferMode & " completed") ' null if not successfull
End Sub

Sub clvTarget_DragEntered(e As DragEvent)
	Log("DragEntered")
	Dim P As B4XView = e.GetEventTarget
	Dim clr As Int
	If IsValidDropEvent(e) Then
		clr = xui.Color_Green
	Else
		clr = xui.Color_Red
	End If
'	Dim p As B4XView = clvNewColumns.AsView
	p.SetColorAndBorder(xui.Color_White, 4dip, clr, 0)
End Sub

Sub clvTarget_DragExited(e As DragEvent)
	Log("DragExited")
	Dim P As B4XView = e.GetEventTarget
	P.SetColorAndBorder(xui.Color_White, 0, 0, 0)
End Sub

Sub clvTarget_DragOver(e As DragEvent)
	Log("Drag over:" & e)
	If IsValidDropEvent(e) Then e.AcceptTransferModes(TransferMode.Move)
End Sub

Sub IsValidDropEvent(e As DragEvent) As Boolean
	Log("Check if is valid:" & e)
	Return e.GetDataIds(0) = "TableData"
End Sub

Sub clvTarget_DragDropped(e As DragEvent)
	Log("drag dropped")
	Log("Source " & e.GetGestureSource & " " & e.GetGestureSource.As(Pane).GetNode(1).As(Label).text)
	Log("Target " & e.GetGestureTarget & " " & e.GetGestureTarget.As(Pane).GetNode(1).As(Label).text)
	e.SetDropCompleted(True)
End Sub

